var textWidth;
var textSize;
var defaultTextSize;
var currentBookmark = 0;
var currentBookmark_textWidth;
var currentBookmark_textSize;

var bookmark_array;
var bookmark_array_index = -1;

var on = false;
var initDone = false;

function init() {
  initDone = true;
  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  try {
    if(!prefService.prefHasUserValue("extensions.ereader.textWidth"))
      prefService.setIntPref("extensions.ereader.textWidth", 800);

    if(!prefService.prefHasUserValue("extensions.ereader.textSize"))
      prefService.setIntPref("extensions.ereader.textSize", 150);

    if(!prefService.prefHasUserValue("extensions.ereader.bookmarks"))
      prefService.setCharPref("extensions.ereader.bookmarks", "");
  } catch (e) {}
}

function eReaderShutdown() {
	if (on) hideEReader();
}

function loadPreferences() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
		textWidth = prefService.getIntPref("extensions.ereader.textWidth");
		textSize = prefService.getIntPref("extensions.ereader.textSize");

		if (bookmark_array_index == -1) {
			var bookmark_str = prefService.getCharPref("extensions.ereader.bookmarks");
			bookmark_array = bookmark_str.split('|');
			bookmark_array_index = findIndex();

			if (bookmark_array_index < bookmark_array.length) {
				var start = bookmark_array[bookmark_array_index].indexOf('=') + 1;
				var temp = bookmark_array[bookmark_array_index].substring(start,bookmark_array[bookmark_array_index].length);
				var temp_array = temp.split(",");
				//if (parseInt(temp_array[0]) > 0 && confirm("Would you resume reading from where you left off?")) {
				if (parseInt(temp_array[0]) > 0) {
					currentBookmark = parseInt(temp_array[0]);
					textWidth = parseInt(temp_array[1]);
					textSize = parseInt(temp_array[2]);
				}
			}
		}

		currentBookmark_textWidth = textWidth;
		currentBookmark_textSize = textSize;
	} catch (e) {}
}

function savePreferences() {
	// Prepare bookmark
	var file = gBrowser.mCurrentBrowser.currentURI.spec;

	if (currentBookmark != 0) bookmark_array[bookmark_array_index] = file + "=" + currentBookmark + "," + textWidth + "," + textSize;

	var bookmark_str = bookmark_array.join('|');

	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	try {
    	prefService.setIntPref("extensions.ereader.textWidth", textWidth);

    	textSize = gBrowser.markupDocumentViewer.textZoom * 100;
    	prefService.setIntPref("extensions.ereader.textSize", textSize);

		prefService.setCharPref("extensions.ereader.bookmarks", bookmark_str);
	} catch (e) {}
}

function findIndex() {
	// Search for file name in array
	file = gBrowser.mCurrentBrowser.currentURI.spec;
	for (var loop=0; loop < bookmark_array.length; loop++)
	{
	    if (bookmark_array[loop].indexOf(file) > -1) return loop;
	}
	return bookmark_array.length;
}

function toggleEReader()
{
	if (!initDone) init();

	newstate = 'false';
	on = false;

	state = document.getElementById('ereader-button').getAttribute('checked');

	if (state == 'false') {
		newstate = 'true';
		on = true;
	}
	state = document.getElementById('ereader-button').setAttribute('checked',newstate);

	if (on) showEReader();
	else hideEReader();
}

function showEReader()
{
	loadPreferences();

	defaultTextSize = gBrowser.markupDocumentViewer.textZoom;
	gBrowser.markupDocumentViewer.textZoom = textSize/100;

	document.getElementById('leftSpace').setAttribute('hidden','false');
	document.getElementById('rightSpace').setAttribute('hidden','false');
	document.getElementById('ereader-bar').setAttribute('hidden','false');
	document.getElementById('nav-bar').setAttribute('hidden','true');
	document.getElementById('PersonalToolbar').setAttribute('hidden','true');
	document.getElementById('customToolbars').setAttribute('hidden','true');
	document.getElementById('appcontent').setAttribute('flex',0);
	document.getElementById('appcontent').setAttribute('width',textWidth);
	gotoBookmark();
}

function hideEReader()
{
	if (gBrowser.mCurrentBrowser.contentWindow.scrollY != currentBookmark) {
		if (confirm("Would you like to bookmark your progress?")) setBookmark();
	}

	savePreferences();

	document.getElementById('leftSpace').setAttribute('hidden','true');
	document.getElementById('rightSpace').setAttribute('hidden','true');
	document.getElementById('ereader-bar').setAttribute('hidden','true');
	document.getElementById('nav-bar').setAttribute('hidden','false');
	document.getElementById('PersonalToolbar').setAttribute('hidden','false');
	document.getElementById('customToolbars').setAttribute('hidden','false');
	document.getElementById('appcontent').setAttribute('flex',1);

	currentBookmark = 0;
	bookmark_array_index = -1;

	gBrowser.markupDocumentViewer.textZoom = defaultTextSize;
}

function setWidth(increment) {
	textWidth+=increment;

	if (textWidth < 50) textWidth = 50;

	text=document.getElementById('appcontent');
	text.setAttribute('width',textWidth);
	savePreferences();
}

function setTextSize(increment) {
	textSize = gBrowser.markupDocumentViewer.textZoom * 100;
	textSize+=increment;

	if (textSize < 50) textSize = 50;

	gBrowser.markupDocumentViewer.textZoom = textSize/100;
	savePreferences();
}

function gotoBookmark() {
	textWidth = currentBookmark_textWidth;
	textSize = currentBookmark_textSize;

	text=document.getElementById('appcontent');
	text.setAttribute('width',textWidth);
	gBrowser.markupDocumentViewer.textZoom = textSize/100;

	gBrowser.mCurrentBrowser.contentWindow.scrollTo(0,currentBookmark);
}

function setBookmark() {
	currentBookmark = gBrowser.mCurrentBrowser.contentWindow.scrollY;
	savePreferences();
	currentBookmark_textWidth = textWidth;
	currentBookmark_textSize = textSize;
	alert("Your bookmark has been set.");
}
